"""
======================================================
:  
:  
:   
: ${Id: }
------------------------------------------------------
:   Mon Nov 19 21:09:12 MSK 2001
======================================================
"""

import UserDict
import sys
from cPickle import dump,load
from Exceptions import *

import Parser

class BaseConfig (UserDict.UserDict) :
        """   /   : 
         --    
        ,      
        . """

        def __init__(self,dict=None, parent={},realm='',arguments=[]) :
                self.parent = parent            #  
                self.realm = realm              #   
                self.arguments = arguments      #      
                self.sections = []              # 
                UserDict.UserDict.__init__(self,dict)

        def __len__(self): return len(self.data) + self.parent.__len__()

        def __getattr__(self,attr) :
                if attr == 'application' :
                        try :
                                return UserDict.UserDict.__getattr__(self,attr)
                        except AttributeError :
                                self.application = getattr(self.parent,attr)
                                return self.application
                else :
                        return UserDict.UserDict.__getattr__(self,attr)

        def __getitem__(self,key) :
                try :
                        return self.data[key]
                except KeyError :
                        return self.parent[key]

        def __setitem__(self,key,value) :
                s = 'switch_' + key
                if hasattr(self,s) and callable(getattr(self,s)) :
                        apply(getattr(self,s),(key,value),{})
                else :
                        self.data[key] = value

        def use(self,key) :
                s = 'switch_' + key
                if hasattr(self,s) and callable(getattr(self,s)) :
                        try :
                                apply(getattr(self,s),(key,),{})
                        except TypeError :
                                raise ConfigError,' %s  ' % key
                else :
                        self[key] = self.default(key)

        def setparent(self,cfg) :       parent = self.cfg

        def keys(self) :        return self.data.keys() + self.parent.keys()
        def items(self) :       return self.data.items() + self.parent.items()
        def values(self) :      return self.data.values() + self.parent.values()
        def has_key(self, key) : return self.data.has_key(key) or self.parent.has_key(key)
     

        def duplicate(self,dict=None,realm='') :
                return self.__class__(parent=self,realm=realm,dict=dict,arguments=self.arguments)

        def default(self,attr) :
                return 1

        def section(self,dict=None,realm='') :
                try :
                        if dict :
                                self.data[realm].update(dict)
                        return self.data[realm]
                except KeyError :
                        self.sections.append(realm)
                        return self.__class__(parent=self,realm=realm,dict=dict,arguments=self.arguments)

        def parents(self) :
                ps = []
                cr = self               
                while type(cr) is not type({}) :
                        ps.append(cr)
                        cr = cr.parent
                ps.append(cr)
                return ps

        def prnt(self,min=0,max=-1) :
                for item in self.parents()[min:max] :
                        print '===> %-20s =' % item.realm + '=' * 45
                        self.save(cfg=item.data,plain=1)
                print '=' * 72

        def getdict(self) :
                dict = self.parent.getdict()            
                dict.update(self.dict)
                return dict

        def dictionary(self,min=0,max=-1) :
                ps = self.parents()
                cfg = {}
                for d in ps[min:max] :
                        cfg.update(d.data)
                return cfg

        def filtered(self,*items) :
                cfg = {}
                for item in items :
                        try :
                                cfg[item] = self[item] 
                        except KeyError :
                                pass
#               print cfg
                return cfg

        def save(self,ouf=sys.stdout,cfg=None,plain=1) :
                if cfg is None : 
                        cfg = self.data

                ks = cfg.keys()
                ks.sort()

                for item in filter(lambda x,cfg=cfg : not isinstance(cfg[x],BaseConfig), ks ) :
                        if type(cfg[item]) is type('') :
                                s = '"%s"' % cfg[item]
                        else :  
                                s = str(cfg[item])
                        ouf.write( "%-40s%s\n" % ("%s = " % item,str(s)) )

                for item in filter(lambda x,cfg=cfg : isinstance(cfg[x],BaseConfig), ks ) :
                        print "\n[%s]\n" % item
                        if plain :
                                cfg[item].save(cfg=cfg[item].data,plain=plain)
                        else :
                                cfg[item].save(plain=plain)


class Switch :
        """\
:         /   :
                 .  ,   
                Application.
:           
:           Wed Nov 21 13:09:53 MSK 2001
:          
                verbose         -  ()  ,
                verbose-stderr  -    stderr,
                debug           -    ,
                
                dump = type     -   ,   :
                        detail  -   ,
                        content -   ,
                        plain   -  
                dump-min        -    ,
                dump-max        -    ,

                help = [chapter]-  ,         
                exit            -     ,
                
                cfg_dump        -      ,
                cfg_load        -     ,
                cfg_read        -   ,
                cfg_clean       -    .
"""
        
        default_cfg = {
                'verbose-level' : 1,
                'verbose-stderr': 0,
                'debug'         : 0,
                'dump-level'    : 0,
                'dump-min'      : 2,
                'dump-max'      : -2,
        }

        def __init__(self) :
                if type(self.parent) is type({}):
                        for attr,value in self.default_cfg.items() :    
                                if not self.data.has_key(attr) :
                                        self.data[attr] = value

        def switch_verbose(self,attr,value=1) :
                if value is not None :
                        self['verbose-level'] = int(value)
                else :
                        self['verbose-level'] = self['verbose-level'] + 1

        def switch_dump(self,attr,value='detail') :
                if value == 'detail' :
                        print '#    [%i:%i]' % (self['dump-min'],self['dump-max'])
                        self.prnt(self['dump-min'],self['dump-max'])

                elif value == 'plain' :
                        print '#    [%i:%i]' % (self['dump-min'],self['dump-max'])
                        self.save(cfg=self.dictionary(self['dump-min'],self['dump-max']))

                elif value == 'content' :
                        print '#   [%i:%i]' % (self['dump-min'],self['dump-max'])
                        n = self['dump-min']
                        for item in self.parents()[self['dump-min']:self['dump-max']] :                 
                                print n,":",item.realm
                                n = n+1
                else :
                        print '#    - detail,plain,content'

        def switch_help(self,attr,value=None) :
                if value == 'cfg' :
                        print self.__doc__
                else :
                        cfg = {'application':sys.argv[0], 'prefix':sys.prefix}
                        cfg.update(self.dictionary(0,-1))
                        print self.application.__doc__ % cfg

        def switch_exit(self,attr,value=None) :
                sys.exit(0)

        def switch_cfg_dump(self,attr,value) :
                try :
                        f = open(value,'w')
                        dump(self,f)
                        f.close()
                except IOError,msg :
                        raise ConfigError,'      (%s): %s' % (value,msg)

        def switch_cfg_load(self,attr,value) :
                """       """
                try :
                        value = str(value)
                        if not hasattr(self,'hasbeenloaded') :
                                f = open(value,'r')
                                self.parent = load(f)
                                f.close()
                                self.hasbeenloaded = 1
                except IOError,msg :
                        raise ConfigError,'     (%s): %s' % (value,msg)
                except EOFError,msg :
                        raise ConfigError,'     (%s):   ' % (value,)

        def switch_cfg_read(self,attr,value) :
                self.parent = self.__class__(realm=value,parent=self.parent)
                Parser.ParseFile(self.parent,open(value,'r'))

        def switch_cfg_clean(self,attr,value=None) :
                if value :
                        try :
                                self[value] = self.parents()[-2][value]
                        except KeyError :
                                raise ConfigError,'  "%s"' % value
                else :
                        self.parent = self.parents()[-2]

class Strict :
        """   /   : 
          -       
        ,      ."""

        def __setitem__(self,key,value) :
                s = 'switch_' + key
                if hasattr(self,s) and callable(getattr(self,s)) :
                        apply(getattr(self,s),(key,value),{})
                else :
                        if not isinstance(value,BaseConfig) :
                                if not self.has_key(key) :
                                        raise ConfigError,'  "%s"' % key
                                elif type(self[key]) != type(value) :
                                        raise ConfigError,'    "%s" (%s -> %s)' % (key,type(value),type(self[key]))
                        self.data[key] = value
                
class Config (Switch, BaseConfig) :
        __doc__ = """\
:         /   : 
                .  
""" + Switch.__doc__

        def __init__(self,dict=None, parent={},realm='',arguments=[],cfg_load=None) :
                if cfg_load :
                        self.cfg_load('cfg_load',cfg_load)
                else :
                        BaseConfig.__init__(self,dict,parent,realm,arguments)
                        Switch.__init__(self)


class ConfigS (Strict, Config) :
        __doc__ = """\
:         /   : 
                  .
""" + Switch.__doc__



        
        
