"""
======================================================
:  
:  
:   
: ${Id: }
------------------------------------------------------
:   Mon Nov 19 21:09:12 MSK 2001
======================================================
"""

import sys
import string
import os
import re
from Exceptions import *


class Parser :
    """   /   : 
     --   /,   eval
    """
    
    def __init__(self,cfg) :
        self.cfg = cfg
        self.read()
    
    def read(*a) :
        pass
    
    def load_value(self,value) :
        try :
            return eval(value)
        except :
            return value
    
    def setconfig(self,attr,value) :
        self.cfg[attr] = value
        return None
    
    def parse(self,line) :
        try :
            attr,value = string.split(line,'=',1)
        except ValueError :
            return self.cfg.use(line)
        #                       return self.setconfig(line,self.cfg.default(line))
        attr = string.strip(attr)
        value = self.load_value(string.strip(value))
        return self.setconfig(attr,value)

class ParseFile (Parser) : 
    """   /   : 
       --     /,
      eval """
    
    cfg_ignore = re.compile('(^[ \t\n]*#.*)|(^[ \t\n]*$)').match
    cfg_sect   = re.compile('^[ \t\n]*\[.*\][ \t\n]*$').match
    cfg_value  = re.compile('^.*[^ \t\n]+.*=.*[^ \t\n]+.*$').match
    
    def __init__(self, cfg, f=sys.stdin) :
        """ .   f    ,
           """
        self.f = f
        self.pcfg = cfg
        Parser.__init__(self,cfg)
    
    def read(self) :
        num = 0
        try :
            while 1 :
                num = num + 1
                line = self.f.readline()
                if not line :
                    break
                elif self.cfg_ignore(line) :
                    continue
                elif self.cfg_sect(line) :
                    realm = string.strip(string.strip(line)[1:-1])
                    self.cfg = self.pcfg[realm] = self.pcfg.section(realm=realm)
                elif self.cfg_value(line) :
                    self.parse(line)
                else :
                    raise ConfigError,'  ' 
        except ConfigError,msg :
            raise ConfigError,"%s : %u -- %s" % (self.f.name,num,msg)
        return

class ParseOpt (Parser) : 
    """   /   : 
       --     
    getopt,    eval """
    
    def __init__(self,cfg) :
        Parser.__init__(self,cfg)
    
    def read(self) :
        for line in sys.argv[1:] :
            if line[0:2] == '--' :
                line = line[2:]
                if self.parse_flag(line,('without','not_use','not','disable'),0) :
                    pass
                elif self.parse_flag(line,('with','have','is','use','do','enable'),1) :
                    pass
                else :
                    self.parse(line)
            elif line[0:1] == '-' :
                pass
            else :
                self.cfg.arguments.append(line)
    
    def parse_flag(self,line,prefix,flag) :
        attr = parse_prefix(line,prefix) 
        if attr :
            self.setconfig(attr,flag)
            return 1
        return None

def parse_prefix(line,prefix=()) :
    for item in prefix :
        l = len(item)
        if line[0:l] == item :
            if line[l] in ('-','=','_') :
                return "use_" + line[l+1:]
            else :
                raise ValueError,line                           
    return None

class ParseEnv (Parser) : 
    """   /   : 
       --   ,  
       ().   
         """
    
    def __init__(self, cfg, prefix='') :
        self.prefix = prefix
        Parser.__init__(self,cfg)
    
    def read(self) :
        for line in filter(lambda s, prefix=self.prefix : prefix == s[0:len(prefix)] ,os.environ.keys()) :
            self.parse(line)
    
    def parse(self,line) :
        return self.setconfig(line[len(self.prefix):],self.load_value(os.environ[line])) 
